/*
 * mydelay.c
 *
 *  Created on: 26 sty 2017
 *      Author: dsosnowski
 */

#include "system.h"
#include "chip.h"
#include "mydelay.h"

#define DELAY_TIMER				LPC_TIMER32_0

//-------------------------------------------------------------------
void MyDelayInit(void){
	//Chip_TIMER_Init(DELAY_TIMER);
	Chip_Clock_EnablePeriphClock(SYSCTL_CLOCK_CT32B0);
}

//-------------------------------------------------------------------
static void MyChip_TIMER_Reset(void) {
	DELAY_TIMER->TCR = (1<<1);	//reset
}

//-------------------------------------------------------------------
static void MyChip_TIMER_Start(void) {
	DELAY_TIMER->TCR = (1<<0);	//clear reset, set enable
}

//-------------------------------------------------------------------
static void MyChip_TIMER_WaitForStop(void) {
	while (DELAY_TIMER->TCR & (1<<0)) {};
}

//-------------------------------------------------------------------
void MyDelayMs(uint32_t msval){
	Chip_TIMER_PrescaleSet(DELAY_TIMER, ((MY_MAIN_CLOCK / 1000) - 1));
	MyChip_TIMER_Reset();

	Chip_TIMER_SetMatch(DELAY_TIMER, 0, msval);
	Chip_TIMER_StopOnMatchEnable(DELAY_TIMER, 0);
	MyChip_TIMER_Start();
	MyChip_TIMER_WaitForStop();
}

//-------------------------------------------------------------------
void MyDelayUs(uint32_t usval){
	Chip_TIMER_PrescaleSet(DELAY_TIMER, ((MY_MAIN_CLOCK / 1000000) - 1));
	MyChip_TIMER_Reset();

	Chip_TIMER_SetMatch(DELAY_TIMER, 0, usval);
	Chip_TIMER_StopOnMatchEnable(DELAY_TIMER, 0);
	MyChip_TIMER_Start();
	MyChip_TIMER_WaitForStop();
}
