/*
 * serial.h
 *
 *  Created on: 28 lis 2017
 *      Author: dsosnowski
 */

#ifndef SERIAL_H_
#define SERIAL_H_


//----------------------------------------------
#define SERIAL_WBUFFER_SIZE			256
#define SERIAL_RBUFFER_SIZE			256

#define SERIAL_IDLE					0
#define SERIAL_BUSY					1
#define SERIAL_ENDING				2
#define SERIAL_READY				3

#define SERIAL_ENTER_CHAR			'\r'
#define SERIAL_MIN_FRAME_LEN		3


#define SERIAL_BAUD_2400			0
#define SERIAL_BAUD_4800			1
#define SERIAL_BAUD_9600			2
#define SERIAL_BAUD_14400			3
#define SERIAL_BAUD_19200			4
#define SERIAL_BAUD_28800			5
#define SERIAL_BAUD_57600			6
#define SERIAL_BAUD_115200			7



void SerialInit(uint32_t baudrate);
void SerialSetBaud(LPC_USART_T *pUART, uint32_t baudrate);

void SerialTimerInit(void);
void SerialTimerStop(void);
void SerialTimerStart(uint8_t charsDelay);

uint8_t SerialWBufferAdd(uint8_t *src);
uint8_t SerialWBufferAddLen(uint8_t *src, uint8_t len);
void SerialWBufferSend(void);
uint8_t SerialWBufferSendCompleteCheck(void);
void SerialWBufferNew(void);

uint8_t SerialRBufferCheck(void);
uint8_t SerialRBufferCounter(void);
void SerialRBufferClear(void);
uint8_t SerialRBufferChar(uint8_t index);
uint8_t *SerialRBufferSrc(uint8_t index);


#endif /* SERIAL_H_ */
