/*
 * serialDebug.c
 *
 *  Created on: 11.02.2018
 *      Author: Procesorowiec
 */

#include "chip.h"
#include "system.h"
#include "serial.h"
#include "serialDebug.h"


//-----------------------------------------------------------------
/*SerialDebugNewReport();
SerialDebugMessage("Hello");
SerialDebugParam("Disp width", DrvWidthGet());
SerialDebugParam("Disp height", DrvHeightGet());
SerialDebugSendReport();
*/

//===================================================================
void SerialDebugNewReport(void){
	SerialWBufferNew();
}

//-------------------------------------------------------------------
void SerialDebugText(uint8_t *text){
	SerialWBufferAdd(text);
}

//------------------------------------------------------------------
uint8_t SerialDebugSendCompleteCheck(void){
	return SerialWBufferSendCompleteCheck();
}

//------------------------------------------------------------------
void SerialDebugSendReport(void){
	SerialWBufferSend();
	while (SerialDebugSendCompleteCheck() == 0){};
}


//===================================================================
void SerialDebugMessage(uint8_t *text){
	SerialDebugText("\r");
	SerialDebugText(text);
}

//-------------------------------------------------------------------
void SerialDebugVal(int32_t val){
	uint8_t result[16];
	uint8_t *buffSrc = &result[15];
	uint8_t i = 0;
	uint8_t minus = 0;

	if (val < 0) {
		minus = 1;
		val *= (-1);
	}

	*buffSrc = 0;
	while (1){
		buffSrc--;
		*buffSrc = ((val % 10) + '0');

		val /= 10;
		if (val == 0) break;

		i++;
		if (i >= 13) break;
	}

	if (minus) {
		buffSrc--;
		*buffSrc = ('-');
	}

	SerialDebugText(buffSrc);
}

//-------------------------------------------------------------------
void SerialDebugParam(uint8_t *name, int32_t val){
	SerialDebugMessage(name);
	SerialDebugText(" = ");
	SerialDebugVal(val);
	SerialDebugText(";");
}
