/*
 * mainscreen.c
 *
 *  Created on: 13.02.2018
 *      Author: Procesorowiec
 */


#include "chip.h"
#include "serialDebug.h"

#include "mydraw.h"
#include "myfonts.h"

#include "menu.h"
#include "mainscreen.h"
#include "settings.h"


//------------------------------------------------------------------------------------------------------
void MianScreenFrame(void){
	FontsStrLineRangeSet(0,  MyDrawScreenWidthGet());

	FontsStrWrite("Frequency [Hz]", 50, 1, fontConsole8font, DRAW_CYAN);
	MyDrawHLine(0, 159, 35, 2, DRAW_BLUE);

	FontsStrWrite("Duty", 70, 40, fontConsole8font, DRAW_CYAN);

	FontsStrWrite("Time H", 70, 70, fontConsole8font, DRAW_CYAN);

	FontsStrWrite("Time L", 70, 100, fontConsole8font, DRAW_CYAN);

	//FontsStrLineRangeSet(132, FontsScreenWidthGet());
	FontsStrWrite("Hz", 135, 18, fontImpact16font, DRAW_GREEN);
	FontsStrWrite("%", 105, 50, fontImpact16font,DRAW_GREEN);
	FontsStrWrite("us", 105, 80, fontImpact16font, DRAW_GREEN);
	FontsStrWrite("us", 105, 110, fontImpact16font, DRAW_GREEN);
}

//------------------------------------------------------------------------------------------------------
void MianScreenValues(void){

	FontsStrLineRangeSet(20, 155);
	FontsValueWrite(GenRealFreqGet(), 155, 10, fontAlien24font, DRAW_GREEN);

	FontsStrLineRangeSet(20, 100);
	FontsValueWrite(GenRealDutyGet(), 100, 50, fontImpact16font, DRAW_GREEN);
	//FontsValueWriteWdot(GenRealDutyGet(), 1, 100, 50, fontImpact16font, DRAW_GREEN);

	FontsStrLineRangeSet(20, 100);
	//FontsValueWrite(GenRealHimpGet(), 100, 80, fontImpact16font, DRAW_GREEN);
	FontsValueWriteWdot(GenRealHimpGet(), 1, 100, 80, fontImpact16font, DRAW_GREEN);

	FontsStrLineRangeSet(20, 100);
	//FontsValueWrite(GenRealLimpGet(), 100, 110, fontImpact16font, DRAW_GREEN);
	FontsValueWriteWdot(GenRealLimpGet(), 1, 100, 110, fontImpact16font, DRAW_GREEN);
}

//------------------------------------------------------------------------------------------------------
void MianScreenMarker(uint8_t pos, uint8_t level){

	static const uint16_t yCoordArray[4] = {10, 50, 80, 110};

	static const uint8_t strArray[MENU_EDITLEVELS][5] = {
			{' ',' ',' ','1', 0},
			{' ',' ','1','0', 0},
			{' ','1','0','0', 0},
			{'1','0','0','0', 0},
			{' ','1','0','k', 0},
			{'1','0','0','k', 0},
	};

	uint8_t i;
	uint16_t y;

	if (level >= MENU_EDITLEVELS) level = (MENU_EDITLEVELS - 1);

	FontsStrLineRangeSet(0, 20);

	for (i = 0; i < MENU_POS_MAX; i++){
		y = yCoordArray[i];

		if (pos == i){
			FontsStrWrite(">>>>", 0, y, fontConsole8font,DRAW_YELLOW);
			FontsStrWrite(&strArray[level][0], 0, y+8, fontConsole8font, DRAW_YELLOW);
		} else {
			FontsStrWrite(" ", 0, y, fontConsole8font, DRAW_YELLOW);
			FontsStrWrite(" ", 0, y+8, fontConsole8font, DRAW_YELLOW);
		}

	}
}
